%{!?kernel: %define kernel %(uname -r)}
%{!?ksrc:   %define ksrc   %(sh %{SOURCE1} srcdir -u %{kernel})}
%{!?kcfg:   %define kcfg   %(sh %{SOURCE1} config -s %{ksrc} -p %{_target_cpu} -u %{kernel})}

Name:		kernel-module-hostap
Version:	0.1.2
Release:	0.fdr.5.1
Summary:	Driver for Intersil Prism2/2.5/3 802.11b wireless cards
License:	GPL
URL:		http://hostap.epitest.fi/
Group:		System Environment/Kernel
Source0:	http://hostap.epitest.fi/releases/hostap-driver-%{version}.tar.gz
Source1:	%{name}-kmodhelper
Patch0:		hostap-makefile.patch
Patch1:		hostap-compat.patch
Patch2:		hostap-download.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:	%{ksrc}/Makefile, %{kcfg}

%description
This is a Linux driver for wireless LAN cards based on Intersil's
Prism2/2.5/3 chipset. The driver supports a so called Host AP mode, i.e.,
it takes care of IEEE 802.11 management functions in the host computer and
acts as an access point. This does not require any special firmware for the
wireless LAN card. In addition to this, it has support for normal station
operations in BSS and possible also in IBSS.

The following rpmbuild options can be used to build this package for a
specific kernel:

--define "kernel <uname -r>"
  Specify the `uname -r` string of the target kernel, for example:
  "kernel 2.4.20-5smp".  The default is `uname -r` for the running kernel.

--define "ksrc <sourcetree>"
  Specify the kernel source directory, for example:
  "ksrc /lib/modules/2.4.20-5smp/build".  The default is
  resolved from <kernel>.

--define "kcfg <conffile>"
  Specify the kernel configuration file to use, for example:
  "kcfg /usr/src/linux-2.4/configs/kernel-2.4.20-i686-smp.config".
  The default is resolved from <kernel>, <ksrc> and <arch>.

--target <arch>
  Specify the target architecture.

--without download
  Build the driver without firmware download support.  The default is to
  build with download support.

%package %{kernel}
Summary:	Driver for Intersil Prism2/2.5/3 802.11b wireless cards
Group:		System Environment/Kernel
Provides:	%{name} = %{epoch}:%{version}-%{release}, kernel-module
Requires(pre):	modutils
Requires:	/boot/vmlinuz-%{kernel}

%description %{kernel}
This is a Linux driver for wireless LAN cards based on Intersil's
Prism2/2.5/3 chipset. The driver supports a so called Host AP mode, i.e.,
it takes care of IEEE 802.11 management functions in the host computer and
acts as an access point. This does not require any special firmware for the
wireless LAN card. In addition to this, it has support for normal station
operations in BSS and possible also in IBSS.


%prep
%setup -q -n hostap-driver-%{version}
%patch0 -p0
%patch1 -p1
%{!?_without_download:%patch2 -p1}


%build
make pccard plx pci \
  CC="%(sh %{SOURCE1} cc -s %{ksrc} -f %{kcfg})" \
  EXTRA_CFLAGS="%(sh %{SOURCE1} modflags -s %{ksrc} -f %{kcfg})" \
  KERNEL_PATH="%{ksrc}" \
  KERNEL_CONFIG="%{kcfg}"


%install
rm -rf "$RPM_BUILD_ROOT"

mkdir -pm 755 "$RPM_BUILD_ROOT"/etc/pcmcia
make install_conf \
  DESTDIR="$RPM_BUILD_ROOT" \
  KERNEL_PATH="%{ksrc}" \
  KERNEL_CONFIG="%{kcfg}"

mkdir -pm 755 "$RPM_BUILD_ROOT"/lib/modules/%{kernel}/kernel

make install_pccard install_plx install_pci \
  MSRC=driver/modules \
  DESTDIR="$RPM_BUILD_ROOT" \
  KERNEL_PATH="%{ksrc}" \
  KERNEL_CONFIG="%{kcfg}" \
  KERNEL_RELEASE="%{kernel}" \
  MODPATH="$RPM_BUILD_ROOT/lib/modules/%{kernel}" \
  MODPATH_CS="$RPM_BUILD_ROOT/lib/modules/%{kernel}"/kernel/drivers/net/wireless \
  MODPATH_PCI="$RPM_BUILD_ROOT/lib/modules/%{kernel}"/kernel/drivers/net/wireless \
  MODPATH_PLX="$RPM_BUILD_ROOT/lib/modules/%{kernel}"/kernel/drivers/net/wireless

# install symbol versioning file
mkdir -pm 755 $RPM_BUILD_ROOT/%{ksrc}/include/linux/modules
install -m 644 driver/modules/hostap.ver $RPM_BUILD_ROOT/%{ksrc}/include/linux/modules

%clean
rm -rf "$RPM_BUILD_ROOT"


%post %{kernel}
if test "`uname -r`" = "%{kernel}" ; then
  depmod -ae >/dev/null 2>&1 || :
fi

%postun %{kernel}
if test "`uname -r`" = "%{kernel}" ; then
  depmod -ae >/dev/null 2>&1 || :
fi


%files %{kernel}
%defattr(-,root,root,-)
%doc ChangeLog COPYING README
%verify(not mtime) %config /etc/pcmcia/hostap_cs.conf
/lib/modules/%{kernel}/kernel/drivers/net/wireless/hostap*.*
%{ksrc}/include/linux/modules/hostap.ver

%changelog
* Sat Apr 17 2004 Thomas Vander Stichele <thomas at apestaart dot org>
- 0.1.2-0.fdr.5: package hostap.ver so packages can be rebuilt that need it

* Wed Jan 14 2004 Steven Pritchard <steve@kspei.com> 0.1.2-0.fdr.4
- Add "--without download" to the description

* Sat Dec 20 2003 Ville Skyttä <ville.skytta at iki.fi> - 0.1.2-0.fdr.3
- Really honor --target.
- New version of kmodhelper.

* Sat Dec 20 2003 Ville Skyttä <ville.skytta at iki.fi> - 0.1.2-0.fdr.2
- Major specfile simplifications, no more hardcoded kernel variants.
- Honor --target and kernel CC properly.
- Run depmod only if installing/uninstalling modules for the running kernel.

* Thu Nov 20 2003 Steven Pritchard <steve@kspei.com> 0.1.2-0.fdr.1
- Second Fedora release candidate
- Fixed to (hopefully) easily allow building for various kernels

* Wed Nov 19 2003 Steven Pritchard <steve@kspei.com> 0.1.2-0.fdr.0.1
- First Fedora release candidate

* Mon Nov 17 2003 Steven Pritchard <steve@kspei.com> 0.1.2
- Updated to 0.1.2

* Thu Oct 30 2003 Steven Pritchard <steve@kspei.com> 0.1.1
- Initial packaging
